咕咕咕了好多天终于有时间写篇博客了_(:з」∠)_

打网赛打到自闭的一周,终于靠这场CF找回了一点信心...

1041A - Heist

\(ans=max\left \{ a_i \right \}-min\left \{ a_i \right \}+1-n\)

#include<bits/stdc++.h>
using namespace std;
#define N 1001
int n,a[N],mx,mi;
int main()
{
mi=;
scanf("%d",&n);
for(int i=;i<=n;i++)
scanf("%d",&a[i]),
mx=max(mx,a[i]),
mi=min(mi,a[i]);
printf("%d\n",mx-mi+-n);
return ;
}

1041B - Buying a TV Set

设\(d=gcd(x,y), X=\frac{x}{d}, Y=\frac{y}{d}\),则\(ans=min(\frac{a}{X},\frac{b}{Y})\)

#include<bits/stdc++.h>
using namespace std;
#define LL long long
LL a,b,x,y;
LL gcd(LL x,LL y){return y?gcd(y,x%y):x;}
int main()
{
scanf("%I64d%I64d%I64d%I64d",&a,&b,&x,&y);
LL d=gcd(x,y);x/=d,y/=d;printf("%I64d\n",min(a/x,b/y));
}

1041C - Coffee Break

难点在于理解题意,题意大致就是把\(n\)分成\(x\)块,使得每块里的数两两相差大于\(d\),求最小的\(x\)

直接排序之后莽就好了,贪心是能保证正确性的

#include<bits/stdc++.h>
using namespace std;
#define N 200001
#define mp make_pair
struct rua{int v,id;}a[N];
set<pair<int,int> >s;
int n,m,d,cnt,f[N];
bool cmp(rua x,rua y){return x.v<y.v;}
int main()
{
scanf("%d%d%d",&n,&m,&d);
for(int i=;i<=n;i++)
scanf("%d",&a[i].v),a[i].id=i;
sort(a+,a+n+,cmp);
s.insert(mp(a[].v,)),f[a[].id]=++cnt;
for(int i=;i<=n;i++)
{
if((*s.begin()).first+d<a[i].v)
f[a[i].id]=(*s.begin()).second,s.erase(s.begin()),s.insert(mp(a[i].v,f[a[i].id]));
else s.insert(mp(a[i].v,++cnt)),f[a[i].id]=cnt;
}
printf("%d\n",cnt);
for(int i=;i<=n;i++)
printf("%d%c",f[i],i<n?' ':'\n');
}

1041D - Glider

显然在气流的开头跳是最优的,因此枚举在哪个气流的开头跳,二分求出能撑到第几个气流结束,通过预处理可以得到在一个区间内可以被抬多久,从而得出答案

#include<bits/stdc++.h>
using namespace std;
#define N 200001
int n,h,ans,s[N];
struct rua{int l,r;}a[N];
bool check(int st,int i,int j)
{
return h-(a[i].r-st)+(s[i]-s[j-])>;
}
int get(int st,int i)
{
int l=i,r=n;
while(l<r)
{
int mid=l+r+>>;
if(check(st,mid,i))l=mid;
else r=mid-;
}
return h+(s[l]-s[i-]);
}
int main()
{
scanf("%d%d",&n,&h);
for(int i=;i<=n;i++)
scanf("%d%d",&a[i].l,&a[i].r),s[i]=s[i-]+a[i].r-a[i].l;
for(int i=;i<=n;i++)
ans=max(ans,get(a[i].l,i));
printf("%d\n",ans);
return ;
}

1041E - Tree Reconstruction

显然\(n\)这个数一定会出现\(n-1\)次,现在只需考虑其他数字的出现情况

考虑\(n-1\)这个数,它出现的次数是等于\(n-1\)所在点到\(n\)所在距离的,且在从\(n\)到\(n-1\)这条路径上出现的数字是不会在输入中出现的。若将剩余出现的数从大到小排序,则有 当前数字出现次数=当前数字所在点到已知路径的距离,这里的已知路径是指已加入点之间的路径。可以发现构造一条链是足以满足题意的,对于空出的点将数字从大到小依次填入,并判断合法性即可。

代码中\(c_i\)为数字\(i\)出现的次数,\(p_i\)为数字\(i\)在答案中的位置,\(x_i\)则代表第\(i\)个位置是否已经被使用

#include<bits/stdc++.h>
using namespace std;
#define N 1005
int n,a[N],b[N],l,j=,c[N],p[N],ans[N],f[N],g[N];
bool x[N];
int main()
{
scanf("%d",&n),c[n]=p[n]=,l=n,x[]=true;
for(int i=;i<=n;i++)
{
scanf("%d%d",&a[i],&b[i]);
if(a[i]<b[i])swap(a[i],b[i]);
if(a[i]<n)return printf("NO\n"),;
c[b[i]]++;
}
for(int i=n-;i>=;i--)if(c[i])
p[i]=p[l]+c[i],l=i,x[p[i]]=true;
for(int i=n;i>=;i--)if(!c[i])
{
while(j<=n && x[j])j++;p[i]=j,x[j]=true;
}
for(int i=;i<=n;i++)ans[p[i]]=i;
for(int i=;i<=n;i++)f[i]=max(f[i-],ans[i]);
for(int i=n;i>=;i--)g[i]=max(g[i+],ans[i]);
for(int i=;i<n;i++)
{
int A=f[i],B=g[i+],xx=;
for(int j=;j<=n;j++)
if(A==a[j] && B==b[j])
{a[j]=b[j]=,xx=;break;}
if(!xx)return printf("NO\n"),;
}
printf("YES\n");
for(int i=;i<=n;i++)printf("%d %d\n",ans[i-],ans[i]);
}

1041F - Ray in the tube

\(y1\)和\(y2\)是没用的,不用管它

由于\(n\)和\(m\)均大于等于1,因此答案至少为2,不少人因此FST

考虑射出去的线打到对面板上所需要走的距离\(d\),假设出发点为0,则打在自己这边上的点的坐标为\(\left \{ 0,2d,4d,6d,8d,... \right \}\),打在对面板上的则是\(\left \{ d,3d,5d,7d,9d,... \right \}\)。若将距离改为\(k\cdot d\),则两个点集分别为\(\left \{ 0,2kd,4kd,6kd,8kd,... \right \}\),\(\left \{ kd,3kd,5kd,7kd,9kd,... \right \}\),可以发现若\(k\)为奇数,两个集合中的点都只会减少不会增加,\(k\)为偶数时则有存在增减的情况,因此设\(k=2^{l}\)一定是最优的

接下去就直接暴力开个map做就好了,比赛的时候害怕FST还加了个优化,就是当\(k\)比较小时直接从\(0\)到\(k-1\)枚举余数,\(k\)较大时才遍历\(n+m\)个坐标。后来发现这个优化只优化了100ms...

#include<bits/stdc++.h>
using namespace std;
#define N 100001
int n,m,y,a[N],b[N];
map<int,int>f,g;
int main()
{
scanf("%d%d",&n,&y);
for(int i=;i<=n;i++)
scanf("%d",&a[i]);
scanf("%d%d",&m,&y);
for(int i=;i<=m;i++)
scanf("%d",&b[i]);
int ans=;
for(int k=;k;k*=)
{
f.clear(),g.clear();
for(int i=;i<=n;i++)
f[a[i]%k]++;
for(int i=;i<=m;i++)
g[b[i]%k]++;
if(k<=)
for(int i=;i<k;i++)
ans=max(ans,f[i]+g[(i+k/)%k]);
else
{
for(auto j:f)ans=max(ans,f[j.first]+g[(j.first+k/)%k]);
for(auto j:g)ans=max(ans,g[j.first]+f[(j.first+k/)%k]);
}
if(k==)
break;
}
printf("%d\n",ans);
return ;
}

Codeforces Round #509 (Div. 2)的更多相关文章

  1. Codeforces Round #509 (Div. 2) F. Ray in the tube(思维)

    题目链接:http://codeforces.com/contest/1041/problem/F 题意:给出一根无限长的管子,在二维坐标上表示为y1 <= y <= y2,其中 y1 上 ...

  2. Codeforces Round #509 (Div. 2) E. Tree Reconstruction(构造)

    题目链接:http://codeforces.com/contest/1041/problem/E 题意:给出n - 1对pair,构造一颗树,使得断开其中一条边,树两边的最大值为 a 和 b . 题 ...

  3. codeforces 1041d// Glider// Codeforces Round #509(Div. 2)

    题意:给出,n和飞行员高度h,n是区间数.在区间里飞行员高度不变,其它地方每秒高度-1,x坐标+1.问在高度变为0以前,x坐标最多加多少? 用数组gap记录本区间右端到下一个区间左端的距离.用sum记 ...

  4. Codeforces Round#509 Div.2翻车记

    A:签到 #include<iostream> #include<cstdio> #include<cmath> #include<cstdlib> # ...

  5. Codeforces Round #509 (Div. 2) A. Heist 贪心

    There was an electronic store heist last night. All keyboards which were in the store yesterday were ...

  6. Codeforces Round #366 (Div. 2) ABC

    Codeforces Round #366 (Div. 2) A I hate that I love that I hate it水题 #I hate that I love that I hate ...

  7. Codeforces Round #354 (Div. 2) ABCD

    Codeforces Round #354 (Div. 2) Problems     # Name     A Nicholas and Permutation standard input/out ...

  8. Codeforces Round #368 (Div. 2)

    直达–>Codeforces Round #368 (Div. 2) A Brain’s Photos 给你一个NxM的矩阵,一个字母代表一种颜色,如果有”C”,”M”,”Y”三种中任意一种就输 ...

  9. cf之路,1,Codeforces Round #345 (Div. 2)

     cf之路,1,Codeforces Round #345 (Div. 2) ps:昨天第一次参加cf比赛,比赛之前为了熟悉下cf比赛题目的难度.所以做了round#345连试试水的深浅.....   ...

随机推荐

  1. 常用的消息队列中间件mq对比

    原文地址:https://blog.csdn.net/qq_30764991/article/details/80239076 消息队列中间件是分布式系统中重要的组件,主要解决应用耦合,异步消息,流量 ...

  2. Aurora — 一个在 MSOffice 内输入 LaTeX 公式的很好用插件

    from http://blog.csdn.net/GarfieldEr007/article/details/51452986 工具名称:Aurora2x  (下载) 压缩包内有详细的安装说明. 刚 ...

  3. 代码,python1

    def main(): try: number1,number2=eval(input("please enter two number")) result=number1/num ...

  4. AWT 新建窗口

    新建一个窗口 包 import java.awt.*; 定义 Frame frm_Draw = new Frame("Text"); 初始化代码 public void Frame ...

  5. WPF 之 调用线程必须为 STA,因为许多 UI 组件都需要

    WPF中,代码中准备控制控件内容时,有时会报错:“ 调用线程必须为 STA,因为许多 UI 组件都需要 ”. 如在winform下面,使用多线程时,控件的值读取是可以的,但如果要更改,那么就必须进行一 ...

  6. Lua中的模块与包

    [前言] 从Lua5.1版本开始,就对模块和包添加了新的支持,可是使用require和module来定义和使用模块和包.require用于使用模块,module用于创建模块.简单的说,一个模块就是一个 ...

  7. Windows2016的 IIS中配置PHP7运行环境

    Windows2016的 IIS中配置PHP7运行环境 在Windows 的IIS(8.0)中搭建PHP运行环境: 一:安装IIS服务器 .进入控制面板>>程序和功能>>打开或 ...

  8. nginx 配置身份验证 http_auth_basic_module

    ngx_http_auth_basic_module模块实现访问必须输入用户名和密码 正确情况向访问,这为我们一些重要资源访问增添了一道安全锁. 语法:     auth_basic_user_fil ...

  9. tensorboard基础使用

    github上的tensorboard项目:https://github.com/tensorflow/tensorboard/blob/master/README.md 目录 基础介绍 基本使用 几 ...

  10. day17递归函数(二分法查找)

    递归函数: 如果函数包含了对其自身的调用,该函数就是递归的: example 1:二分法查找的实现: def find_recursion(l,aim,start=0,end=None): #end不 ...